// 3dEngine.h: interface for the C3dEngine class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_3DENGINE_H__FC73ADE1_C701_11D2_BE0A_0020781069DC__INCLUDED_)
#define AFX_3DENGINE_H__FC73ADE1_C701_11D2_BE0A_0020781069DC__INCLUDED_

#include "Rotation.h"	// Added by ClassView
#include "Vertex.h"	// Added by ClassView
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define MAJORVERSION 1
#define MINORVERSION 42

// axis identifiers
#define XAXIS 0
#define YAXIS 1
#define ZAXIS 2

typedef struct {
	double X;
	double Y;
} CARTCOORD;

typedef struct {
	double Distance;
	double Angle;
} POLARCOORD;

class C3dEngine  
{
public:
	C3dEngine();
	virtual ~C3dEngine();
	// interface
	void C3dEngine::Rotate(double* X,double* Y,double centerx,double centery,double Angle);
	void Rotate3d(double* X,double* Y,double* Z,
		double AngleX,double AngleY,double AngleZ,
		double CenterX = 0.0,double CenterY = 0.0,double CenterZ = 0.0);
	void Transform3d(double* X,double* Y,double* Z,
		double DeltaX,double DeltaY,double DeltaZ);
	void Scale(double* X,double* Y,
		double OffsetX,double OffsetY,double factor);
	void Scale3d(double* X,double* Y,double* Z,double factor,
		double OffsetX = 0.0,double OffsetY = 0.0,double OffsetZ = 0.0);
	void Stretch(double* X,double* Y,double* Z,
		double OffsetX,double OffsetY,double OffsetZ,
		double FactorX,double FactorY,double FactorZ);
	void Project(double X,double Y,double Z,double* ProjX,double* ProjY,CVertex* viewctr);
	// cartesian to polar conversion
	void ConvertCoord(CARTCOORD cart,POLARCOORD* polar);
	// polar to cartesian conversion
	void ConvertCoord(POLARCOORD polar,CARTCOORD* cart);
public:
	CVertex FindMiddle(CVertex* v1,CVertex* v2);
	double CalcDistance(CVertex v1,CVertex v2);
	CRotation m_ViewRotation;
	double m_ViewDistance;
	// attributes
	double pi;
	CVertex m_ViewPosition;
	CVector m_ViewDirection;
	double Radian;
};

#endif // !defined(AFX_3DENGINE_H__FC73ADE1_C701_11D2_BE0A_0020781069DC__INCLUDED_)
