// ConvertMetric.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <afxdllx.h>
#include "plugin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CFSObject* piobject = NULL;

static AFX_EXTENSION_MODULE ConvertMetricDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("CONVERTMETRIC.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(ConvertMetricDLL, hInstance))
			return 0;

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		new CDynLinkLibrary(ConvertMetricDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("CONVERTMETRIC.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(ConvertMetricDLL);
	}
	return 1;   // ok
}

int ExecutePlugin()
{
	int result = PLUGIN_RELOAD;

	// create the object
	piobject = new CFSObject;

	// load the data transfer file created by FSDS
	LoadFSC(piobject);

	CObjectPart* part;
	CVertex* vert;
	int nPart,nVert;
	double fMult = .3048;
	int nParts = piobject->PartCount();
	int nVertices;
	int nTotVertices = 0;
	if(AfxMessageBox("Click Yes to convert from Meters to Feet,\n"
		"No to convert from Feet to Meters",MB_YESNO) == IDYES)
	{
		// meters to feet
		for(nPart = 0;nPart < nParts;nPart++)
		{
			part = piobject->m_PartArray[nPart];
			// scale object axis location
			part->m_Axis.Location.X /= fMult;
			part->m_Axis.Location.Y /= fMult;
			part->m_Axis.Location.Z /= fMult;
			
			// scale the vertices
			nVertices = part->VertexCount();
			for(nVert = 0;nVert < nVertices;nVert++)
			{
				vert = part->m_VertexArray[nVert];
				vert->X /= fMult;
				vert->Y /= fMult;
				vert->Z /= fMult;
			}
			nTotVertices +=  nVertices;
		}
		CString cs;
		cs.Format("Meters to Feet conversion complete!\n"
			"Scaled %d vertices in %d parts",nTotVertices,nParts);
		AfxMessageBox(cs);
	} else
	{
		// feet to meters
		for(nPart = 0;nPart < nParts;nPart++)
		{
			part = piobject->m_PartArray.GetAt(nPart);//[nPart];
			// scale object axis location
			part->m_Axis.Location.X *= fMult;
			part->m_Axis.Location.Y *= fMult;
			part->m_Axis.Location.Z *= fMult;
			
			// scale the vertices
			nVertices = part->VertexCount();
			for(nVert = 0;nVert < nVertices;nVert++)
			{
				vert = part->m_VertexArray[nVert];
				TRACE("\n%f %f %f  |  ",vert->X,vert->Y,vert->Z);
				vert->X *= fMult;
				vert->Y *= fMult;
				vert->Z *= fMult;
			}
			nTotVertices +=  nVertices;
		}
		CString cs;
		cs.Format("Feet to Meters conversion complete!\n"
			"Scaled %d vertices in %d parts",nTotVertices,nParts);
		AfxMessageBox(cs);
	}

	// resave the object
	StoreFSC(piobject);

	// free the memory from our object
	delete piobject;

	return(result);
}