// FSObject.h: interface for the CFSObject class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FSOBJECT_H__72615837_C29A_11D2_BE0A_0020781069DC__INCLUDED_)
#define AFX_FSOBJECT_H__72615837_C29A_11D2_BE0A_0020781069DC__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <afxtempl.h>
#include "ObjectPart.h"	// Added by ClassView

#define RENDERTYPE_SOLID 0
#define RENDERTYPE_LINES 1
#define RENDERTYPE_DOTS  2

typedef struct {
public:
	CString Filename;
	void* d3dTexture;	// cast to DIRECTDRAWSURFACE7*
	int refcount;
	CFSBitmap Texture;
} d3dTextureEntry;

class CFSObject  
{
public:
	ULONG AssignPartID(CObjectPart *part);
	ULONG CheckParentID(CString ParentName);
	void CheckPartIDs();
	ULONG m_NextPartID;
	BOOL m_CrashDetect;
	void ClearParts();
	void GetSelectedPartBounds(BoundingBox* bounds);
	double GetLargestExtent();
	int PartCount();
	void CalcNormals();
	int SelectedPartCount();
	void GetBounds(BoundingBox * bounds);
	BoundingBox m_Bounds;
	CObjectPart* GetCurrentPart();
	void Serialize(CArchive& ar);
	short int m_RefType;
	short int m_Range;
	int m_AreaType;
	CArray<CObjectPart*, CObjectPart*&> m_PartArray;	// array of object parts
	CArray<d3dTextureEntry, d3dTextureEntry&> m_d3dTextureArray;
	int m_CurrentPart;	// index to currently selected part
	CString m_TopLat;
	CString m_BottomLat;
	CString m_RightLon;
	CString m_LeftLon;
	CString m_AreaLat;
	CString m_AreaLon;
	double m_AreaAltitude;
	CFSObject();
	CFSObject(const CFSObject& obj);
	virtual ~CFSObject();

};

#endif // !defined(AFX_FSOBJECT_H__72615837_C29A_11D2_BE0A_0020781069DC__INCLUDED_)
