// Polygon.h: interface for the CPolygon class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_POLYGON_H__9AD62FA4_C1E7_11D2_BE0A_0020781069DC__INCLUDED_)
#define AFX_POLYGON_H__9AD62FA4_C1E7_11D2_BE0A_0020781069DC__INCLUDED_

#include <afxtempl.h>
#include "Vector.h"	// Added by ClassView
#include "Vertex.h"	// Added by ClassView
#include "FSBitmap.h"	// Added by ClassView

#define COMPVAL .7071	// value to compare against unit vector
						// to determine which texture to apply

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define NORMAL 0
#define TEXTURED 1
#define SMOOTH 2
#define SMOOTH_TEXTURED 3

class CPolygon  
{
public:
	BOOL m_Hidden;
	int TextureFace();
	CFSBitmap m_Texture;
	void Mirror(BOOL mirror);
	void FlipSurfaceNormal();
	CVertex m_Center;
	double CalcDistance(CVertex vert);
	double m_Distance;
	void Serialize(CArchive& ar);
	BOOL m_LineClosed;
	BOOL m_Line;
	BOOL m_TwoSided;
	unsigned short m_Color;
	COLORREF m_rgbaColor;
	int m_CurrentPoint;
	BOOL m_Selected;
	void AddPoint(int Index);
	CVector m_SurfaceNormal;						// surface normal
	CArray<int, int&> m_PointArray;					// vertices
	int m_TextureApplication;						// texture application
	int m_TextureSide;								// texture app side
	CArray<CPoint, CPoint&> m_TextureOffsetArray;	// texture offsets
	CPolygon();
	virtual ~CPolygon();

};

#endif // !defined(AFX_POLYGON_H__9AD62FA4_C1E7_11D2_BE0A_0020781069DC__INCLUDED_)
